#include "CAnsiString.h"

const char CAnsiString::NullChar = '\0';

CAnsiString& CAnsiString::Replace( CAnsiString& StringOld, CAnsiString& StringNew )
{
	return Replace(StringOld, StringNew, 1, MAX_DWORD);
}
CAnsiString& CAnsiString::Replace( CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition)
{
	return Replace(StringOld, StringNew, nStartPosition, MAX_DWORD);
}
CAnsiString& CAnsiString::Replace( CAnsiString& StringOld,CAnsiString& StringNew, DWORD nStartPosition,DWORD nCount)
{
	DWORD nFindCount = FindCount(StringOld,nStartPosition);
	
	if ( nCount < nFindCount)
		nFindCount = nCount;
	
	DWORD nStringLength = GetLength();
	DWORD nStringOldLength = StringOld.GetLength();
	DWORD nStringNewLength = StringNew.GetLength();
	
	if ( !nFindCount || !nStringLength || nStartPosition >  nStringLength || !nCount || !nStringOldLength)
		return *this;
	
	DWORD nOutputLength = nStringLength;
	nOutputLength += nStringNewLength * nFindCount;
	nOutputLength -= nStringOldLength * nFindCount;
	if (!nOutputLength)
		return *this;
	nOutputLength++;
	
	if(!nStartPosition)
		nStartPosition++;
	
	DWORD nMatch = ZERO;
	LPSTR pf,ps;
	
	DWORD nUnmatchedStart = 1;
	
	CAnsiString astr;
	if (!astr._Buffer.SetBufferSize(nOutputLength))
		return *this = astr;//error memory alloc
	
	DWORD i;
	for(i = nStartPosition; (i + nStringOldLength) - 1 <= nStringLength; i++)
	{
		if ( _Buffer[i - 1] == StringOld._Buffer[0] &&	_Buffer[(i + nStringOldLength) - 2] == StringOld._Buffer[nStringOldLength - 1])
		{
			nMatch = 2;
			if ( nMatch < nStringOldLength)
			{
				// point to one character forward
				ps = &_Buffer[i];
				pf = &StringOld._Buffer[1];
				
				while(nMatch < nStringOldLength)
				{
					if (*ps != *pf)
					{
						nMatch = ZERO;
						break;
					}
					nMatch++;
				}
			}
			if (nMatch)// match find
			{
				if (nUnmatchedStart < i)
					astr._Buffer.AppendData(&_Buffer[nUnmatchedStart - 1],i - nUnmatchedStart);
				if (nStringNewLength)
					astr._Buffer.AppendData(StringNew.GetPtr(),nStringNewLength);
				
				nUnmatchedStart = i + nStringOldLength;
				i += nStringOldLength -1;
				
				nFindCount--;
				if (!nFindCount)
				{
					break;
				}
				
			}
		}
	}
	if (nUnmatchedStart < nStringLength)
		astr._Buffer.AppendData(&_Buffer[nUnmatchedStart - 1],(nStringLength - nUnmatchedStart) + 1);
	
	astr._Buffer[nOutputLength - 1] = '\0';
	
	return *this = astr.ReturnFinal();
}
DWORD CAnsiString::FindCount(CAnsiString& String)
{
	return FindCount(String,1);
}
DWORD CAnsiString::FindCount(CAnsiString& String, DWORD nStartPosition, DWORD nMaxCount)
{
	DWORD nCount = ZERO;
	DWORD nMax = nMaxCount;
	DWORD nStringLength = GetLength();
	DWORD nFindLength = String.GetLength();
	
	if ( nStartPosition > nStringLength || !nStringLength || !nFindLength)
		return ZERO;
	
	if(!nStartPosition)
		nStartPosition++;
	
	DWORD nMatch = ZERO;
	LPSTR pf,ps;
	
	for(DWORD i = nStartPosition; (i + nFindLength) - 1 <= nStringLength; i++)
	{
		if ( _Buffer[i - 1] == String._Buffer[0] &&	_Buffer[(i + nFindLength) - 2] == String._Buffer[nFindLength - 1])
		{
			nMatch = 2;
			if ( nMatch < nFindLength)
			{
				// point to one character forward
				ps = &_Buffer[i];
				pf = &String._Buffer[1];
				
				while(nMatch < nFindLength)
				{
					if (*ps != *pf)
					{
						nMatch = ZERO;
						break;
					}
					nMatch++;
				}
			}
			if (nMatch)
			{
				i += nFindLength -1;
				nCount++;
				nMax--;
				if(!nMax)
					break;
			}
		}
	}
	return nCount;
}
DWORD CAnsiString::FindCount(CAnsiString& String, DWORD nStartPosition)
{
	return FindCount(String, nStartPosition,MAX_DWORD);
}
CAnsiString& CAnsiString::operator +=(LPCSTR lpString)
{
	return Append(lpString);
}
CAnsiString& CAnsiString::operator = (LPCSTR lpString)
{
	return SetString(lpString);
}
CAnsiString& CAnsiString::Left( DWORD nSize )
{
	Trunc(nSize);
	return *this;
	
}
CAnsiString& CAnsiString::SetString(LPCSTR lpString)
{
	if ( !lpString)
		return MakeEmpty();
	
	DWORD nLength = Len(lpString);
	
	if (!nLength)
		return MakeEmpty();
	
	CAnsiString astr;
	DWORD nSize = nLength + 1;
	astr._Buffer.SetBufferSize(nSize);
	astr._Buffer.WriteData(lpString,nLength);
	++astr._Buffer;
	astr._Buffer[nLength] = '\0';
	
	return *this = astr.ReturnFinal();	
}
CAnsiString& CAnsiString::SetString(LPCSTR lpString,DWORD nLength)
{
	if ( !lpString || !nLength)
		return MakeEmpty();
	
	DWORD nLen = Len(lpString);
	
	if (nLen <= nLength)
		return SetString(lpString);
	
	CAnsiString astr;
	DWORD nSize = nLength + 1;
	astr._Buffer.SetBufferSize(nSize);
	astr._Buffer.WriteData(lpString,nLength);
	++astr._Buffer;
	astr._Buffer[nLength] = '\0';
	
	return *this = astr.ReturnFinal();
	
}
CAnsiString& CAnsiString::Right( DWORD nSize ) 
{
	DWORD nLength = GetLength();
	
	if 	( nSize >= nLength || !nLength)
		return *this;
	
	if  ( !nSize)
		return MakeEmpty();
	
	CAnsiString astr;
	DWORD nBufferSize = nSize + 1;
	astr._Buffer.SetBufferSize(nBufferSize);
	astr._Buffer.WriteData(&_Buffer[(nLength - nSize)],nSize);
	++astr._Buffer;
	astr._Buffer[nSize] = '\0';
	
	return *this = astr.ReturnFinal();
	
}
// nStartPosition is one based index but 0 equal to 1
CAnsiString& CAnsiString::Mid( DWORD nStartPosition, DWORD nSize )
{
	DWORD nLength = GetLength();
	
	if ( !nSize || !nLength || nStartPosition > nLength) 
		return MakeEmpty();
	
	if (!nStartPosition)
		nStartPosition++;
	
	if ( nSize > nLength - nStartPosition)
		nLength = (nLength - nStartPosition) + 1;
	else
		nLength = nSize;
	
	CAnsiString astr;
	
	DWORD nBufferSize = nLength + 1;
	astr._Buffer.SetBufferSize(nBufferSize);
	astr._Buffer.WriteData(&_Buffer[nStartPosition - 1],nLength);
	++astr._Buffer;
	astr._Buffer[nLength] = '\0';
	
	return *this = astr.ReturnFinal();
}
CAnsiString& CAnsiString::Mid( DWORD nStartPosition)
{
	return Mid(nStartPosition,MAX_DWORD);
}
// Set the Size of String (See Left Function)
// Position(index) not Zero based.
CAnsiString& CAnsiString::Trunc( DWORD nPosition )
{
	if ( nPosition >= GetLength() )
		return *this;
	
	if (nPosition)
	{
		_Buffer.SetDataSize(nPosition + 1);
		_Buffer.SetBufferSize(nPosition + 1,TRUE);
		_Buffer[nPosition] = '\0';
	}
	else
	{
		_Buffer.EmptyBuffer();
	}
	return *this;
}
CAnsiString& CAnsiString::SetString(CAnsiString& String)
{	
	return *this = String;
}
CAnsiString& CAnsiString::SetString(CAnsiString& String,DWORD nLength)
{
	if ( nLength >= String.GetLength())
		return *this = String;
	
	CAnsiString astr;
	if (nLength)
	{
		astr._Buffer.SetBufferSize(nLength + 1);
		astr._Buffer.WriteData(String._Buffer,nLength);
		++astr._Buffer;
		astr._Buffer[nLength] = '\0';
	}
	return *this = astr.ReturnFinal();
}

CAnsiString& CAnsiString::MakeUpper(void)
{
	LPSTR ptr = GetPtr();
	while (*ptr)
	{
		if (*ptr > 96 && *ptr < 123)
			*ptr = *ptr - 32;
		ptr++;
	}
	
	return *this;
}
CAnsiString& CAnsiString::MakeLower(void)
{
	LPSTR ptr = GetPtr();
	while (*ptr)
	{
		if (*ptr > 64 && *ptr < 91)
			*ptr = *ptr + 32;
		ptr++;
	}
	return *this;
}
CAnsiString& CAnsiString::MakeReverse(void)
{
	if (GetLength() > 1) //At least to character to swap 
	{
		char c;
		LPSTR lpBegin, lpEnd;
		lpBegin = GetPtr();
		lpEnd = &_Buffer[GetLength() - 1];
		while ( lpBegin < lpEnd )
		{
			c=*lpBegin;
			*lpBegin=*lpEnd;
			*lpEnd=c;
			lpBegin++;
			lpEnd--;
		}
	}
	return *this;
}
CAnsiString& CAnsiString::MakeEmpty(void)
{
	_Buffer.EmptyBuffer();
	return *this;
}
LPSTR CAnsiString::operator() ()
{
	return GetPtr();
}

BOOL CAnsiString::IsEqualsIgnoreCase(CAnsiString& String)
{
	CAnsiString astrLeft,astrRight;
	astrLeft  = *this;
	astrRight = String;
	
	astrLeft.MakeLower();
	astrLeft.MakeLower();
	
	return FALSE;
}
BOOL CAnsiString::IsEquals(CAnsiString& String)
{
	DWORD i = 0;
	
	if ( GetLength() == String.GetLength())
	{
		if (GetLength())
		{
			if ( _Buffer[GetLength() - 1] == String._Buffer[GetLength() - 1])
			{
				while( _Buffer[i] )
				{
					if ( _Buffer[i] != String._Buffer[i] )
						return FALSE;
					if ( _Buffer[i + 1] == '\0')
						return TRUE;
					i++;
				}
				return FALSE;
			}
			return FALSE;
			
		}
		return TRUE;
	}
	return FALSE;
}
BOOL CAnsiString::operator == (CAnsiString& String)
{
	return IsEquals(String);
}
BOOL CAnsiString::operator != (CAnsiString& String)
{
	return !IsEquals(String);
}
CAnsiString CAnsiString::operator +(CAnsiString& String)
{
	CAnsiString astr;
	astr._Buffer.SetBufferSize(_Buffer.GetDataSize() + String.GetLength());
	astr._Buffer.SetData(_Buffer);
	--astr._Buffer;
	astr._Buffer.AppendData(String._Buffer);
	return astr.ReturnFinal();
}
CAnsiString& CAnsiString::ReturnFinal(void)
{
	_Buffer._MakeAttachable(TRUE);
	return *this;
}
CAnsiString& CAnsiString::Prepend(CAnsiString& String)
{
	
	if ( String.GetLength() || GetLength() )//must one string has length
	{
		
		if ( String.GetLength() )
		{
			CAnsiString astr;
			
			DWORD dwSize = String._Buffer.GetDataSize();
			dwSize += _Buffer.GetDataSize();
			if (_Buffer.GetDataSize())
				--dwSize;
			
			astr._Buffer.SetBufferSize(dwSize);
			
			astr._Buffer.AppendData(String._Buffer);
			--astr._Buffer;
			if (_Buffer.GetDataSize())
				astr._Buffer.AppendData(_Buffer);
			else
				++astr._Buffer;
			_Buffer._Attach(astr._Buffer);
			
		}
	}
	return *this;
}

CAnsiString& CAnsiString::Append(LPCSTR lpString) 
{
	DWORD nLength = LenB(lpString);
	
	if ( nLength )
	{
		CAnsiString astr;
		
		DWORD dwSize = nLength;
		
		dwSize += _Buffer.GetDataSize();
		if (_Buffer.GetDataSize())
			--dwSize;
		
		astr._Buffer.SetBufferSize(dwSize);
		
		astr._Buffer.AppendData(_Buffer);
		
		if (_Buffer.GetDataSize())
		{
			--astr._Buffer;
			CopyMemory(&astr._Buffer[astr._Buffer.GetDataSize()],lpString,nLength);
			astr._Buffer.SetDataSize(astr._Buffer.GetDataSize() + nLength);
		}
		else
		{
			CopyMemory(astr._Buffer.GetPtr(),lpString,nLength);
			astr._Buffer.SetDataSize(nLength);
		}
		_Buffer._Attach(astr._Buffer);		
	}
	
	return *this;
}
CAnsiString& CAnsiString::Append(CAnsiString& String)
{
	if ( String.GetLength() )
	{
		CAnsiString astr;
		
		DWORD dwSize = String._Buffer.GetDataSize();
		dwSize += _Buffer.GetDataSize();
		if (_Buffer.GetDataSize())
			--dwSize;
		
		astr._Buffer.SetBufferSize(dwSize);
		
		astr._Buffer.AppendData(_Buffer);
		
		if (_Buffer.GetDataSize())
			--astr._Buffer;
		
		astr._Buffer.AppendData(String._Buffer);
		_Buffer._Attach(astr._Buffer);		
	}
	
	return *this;
}
CAnsiString& CAnsiString::operator +=(CAnsiString& String)
{
	return Append(String);
}
BOOL CAnsiString::IsEmpty(void)
{
	if (!_Buffer.GetDataSize())
		return TRUE;
	return FALSE;
}
DWORD CAnsiString::GetLength(void)
{
	if (!_Buffer.GetDataSize())
		return ZERO;
	return _Buffer.GetDataSize() - 1;
}
LPSTR CAnsiString::GetPtr(void)
{
	if (_Buffer.GetPtr() )
		return _Buffer.GetPtr();
	return (LPSTR)&NullChar;
}

CAnsiString::CAnsiString(void)
{
}
CAnsiString& CAnsiString::operator = (CAnsiString& String)
{
	if (this == &String ) return *this;
	_Buffer.SetBuffer(String._Buffer);
	
	return *this;
}
CAnsiString::CAnsiString(CAnsiString& String)
{
	//if (String._Buffer._IsAttachable())
	//	_Buffer._MakeAttachable(TRUE);
	
	_Buffer.SetBuffer(String._Buffer);
}
CAnsiString::CAnsiString(LPCSTR lpString)
{
	SetString(lpString);
}
CAnsiString::~CAnsiString()
{
}
//____________________________________________________
CAnsiString Str(LPCSTR lpString)
{
	CAnsiString astr(lpString);
	return astr.ReturnFinal();
}
//...
DWORD FindCount(CAnsiString& StringSource, CAnsiString& String)
{
	return StringSource.FindCount(String);
}
DWORD FindCount(CAnsiString& StringSource, CAnsiString& String, DWORD nStartPosition)
{
	return StringSource.FindCount(String,nStartPosition);
}
DWORD FindCount(CAnsiString& StringSource, CAnsiString& String, DWORD nStartPosition, DWORD nMaxCount)
{
	return StringSource.FindCount(String,nStartPosition,nMaxCount);
}
CAnsiString& Replace(CAnsiString& String, CAnsiString& StringOld, CAnsiString& StringNew )
{
	CAnsiString astr(String);
	astr.Replace(StringOld, StringNew);
	return astr.ReturnFinal();
}
CAnsiString& Replace(CAnsiString& String, CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition)
{
	CAnsiString astr(String);
	astr.Replace(StringOld, StringNew, nStartPosition);
	return astr.ReturnFinal();
}
CAnsiString& Replace(CAnsiString& String, CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition,DWORD nCount)
{
	CAnsiString astr(String);
	astr.Replace(StringOld, StringNew, nStartPosition, nCount);
	return astr.ReturnFinal();
}
CAnsiString StrReverse(CAnsiString& String)
{
	CAnsiString astr(String);
	return astr.MakeReverse().ReturnFinal();
	
}
CAnsiString StrReverse(LPCSTR lpString)
{
	CAnsiString astr(lpString);
	return astr.MakeReverse().ReturnFinal();
}
CAnsiString UCase(CAnsiString& String)
{
	CAnsiString astr(String);
	return astr.MakeUpper().ReturnFinal();
}
CAnsiString LCase(CAnsiString& String)
{
	CAnsiString astr(String);
	return astr.MakeLower().ReturnFinal();
	
}
CAnsiString Mid(CAnsiString& String ,DWORD nStartPosition, DWORD nSize )
{
	CAnsiString astr(String);
	return astr.Mid(nStartPosition,nSize).ReturnFinal();
	
}
CAnsiString Mid(CAnsiString& String ,DWORD nStartPosition)
{
	CAnsiString astr(String);
	return astr.Mid(nStartPosition).ReturnFinal();
}
CAnsiString Left(CAnsiString& String ,DWORD nSize )
{
	CAnsiString astr(String);
	return astr.Left(nSize).ReturnFinal();
}
CAnsiString Right(CAnsiString& String ,DWORD nSize )
{
	CAnsiString astr(String);
	return astr.Right(nSize).ReturnFinal();
}
CAnsiString UCase(LPCSTR lpString)
{
	CAnsiString astr(lpString);
	return astr.MakeUpper().ReturnFinal();
	
}
CAnsiString LCase(LPCSTR lpString)
{
	CAnsiString astr(lpString);
	return astr.MakeLower().ReturnFinal();
	
}
CAnsiString Mid(LPCSTR lpString ,DWORD nStartPosition, DWORD nSize )
{
	CAnsiString astr(lpString);
	return astr.Mid(nStartPosition,nSize).ReturnFinal();
	
}
CAnsiString Mid(LPCSTR lpString ,DWORD nStartPosition)
{
	CAnsiString astr(lpString);
	return astr.Mid(nStartPosition).ReturnFinal();
	
}
CAnsiString Left(LPCSTR lpString ,DWORD nSize )
{
	CAnsiString astr(lpString);
	return astr.Left(nSize).ReturnFinal();
	
}
CAnsiString Right(LPCSTR lpString ,DWORD nSize )
{
	CAnsiString astr(lpString);
	return astr.Right(nSize).ReturnFinal();
}

DWORD Len(CAnsiString& String)
{
	return String.GetLength();
}
DWORD LenB(CAnsiString& String)
{
	return String._Buffer.GetDataSize();
}
DWORD Len(LPCSTR lpString)
{
	DWORD cc = 0;
	LPSTR ptr = (LPSTR) lpString;
	while(*ptr)
	{
		ptr++;
		cc++;
	}
	return cc;
}
DWORD LenB(LPCSTR lpString)
{
	DWORD cc = Len(lpString);
	if (cc)
		return cc + 1;
	return ZERO;
}
/*
This file is a part of CIF.
Project Core Information Foundation (CIF).
Developed by Muhammad Arshad Latti.
Location Sargodha (Pakistan).
arshadlatti@gmail.com
http://arshadlatti.angelfire.com/
*/
