#ifndef __C_ANSI_STRING_H__
#define __C_ANSI_STRING_H__

#include "CBuffer.h"

#ifndef ZERO
#define ZERO 0
#endif

#ifndef MAX_DWORD
#define MAX_DWORD 0xffffffff
#endif

class CAnsiString;

DWORD Len(CAnsiString& String);
DWORD LenB(CAnsiString& String);//Returns the bytes required to store a variable
DWORD FindCount(CAnsiString& StringSource, CAnsiString& String);
DWORD FindCount(CAnsiString& StringSource, CAnsiString& String, DWORD nStartPosition);
DWORD FindCount(CAnsiString& StringSource, CAnsiString& String, DWORD nStartPosition, DWORD nMaxCount);
CAnsiString& Replace(CAnsiString& String, CAnsiString& StringOld, CAnsiString& StringNew );
CAnsiString& Replace(CAnsiString& String, CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition);
CAnsiString& Replace(CAnsiString& String, CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition,DWORD nCount);

CAnsiString UCase(CAnsiString& String);
CAnsiString LCase(CAnsiString& String);
CAnsiString Mid(CAnsiString& String, DWORD nStartPosition, DWORD nSize );
CAnsiString Mid(CAnsiString& String , DWORD nStartPosition);
CAnsiString Left(CAnsiString& String , DWORD nSize );
CAnsiString Right(CAnsiString& String , DWORD nSize );
CAnsiString StrReverse(CAnsiString& String);

DWORD Len(LPCSTR lpString);
DWORD LenB(LPCSTR lpString);//Returns the bytes required to store a variable
CAnsiString UCase(LPCSTR lpString);
CAnsiString LCase(LPCSTR lpString);
CAnsiString Mid(LPCSTR lpString ,DWORD nStartPosition, DWORD nSize );
CAnsiString Mid(LPCSTR lpString ,DWORD nStartPosition);
CAnsiString Left(LPCSTR lpString ,DWORD nSize );
CAnsiString Right(LPCSTR lpString ,DWORD nSize );
CAnsiString StrReverse(LPCSTR lpString);

//...
CAnsiString Str(LPCSTR lpString);

//...
class CAnsiString
{
	static const char NullChar;
public:
	CBuffer _Buffer;	
	
	CAnsiString(void);
	CAnsiString(CAnsiString& String);
	~CAnsiString();
	
	CAnsiString(LPCSTR lpString);
	
	BOOL IsEmpty(void);
	DWORD GetLength(void);
	LPSTR GetPtr(void);
	
	CAnsiString& Append(CAnsiString& String); 
	CAnsiString& Prepend(CAnsiString& String);
	CAnsiString& ReturnFinal(void);
	
	CAnsiString& Left( DWORD nSize );
	CAnsiString& Right( DWORD nSize ) ;
	CAnsiString& Mid( DWORD nStartPosition, DWORD nSize );
	CAnsiString& Mid( DWORD nStartPosition);
	CAnsiString& MakeEmpty(void);
	CAnsiString& MakeReverse(void);
	CAnsiString& MakeUpper(void);
	CAnsiString& MakeLower(void);
	CAnsiString& Trunc( DWORD nPosition );
	CAnsiString& SetString(CAnsiString& String);
	CAnsiString& SetString(CAnsiString& String,DWORD nLength);
	
	CAnsiString& operator = (CAnsiString& String);
	CAnsiString& operator +=(CAnsiString& String);
	CAnsiString operator +(CAnsiString& String);
	BOOL operator == (CAnsiString& String);
	BOOL operator != (CAnsiString& String);	
	BOOL IsEquals(CAnsiString& String); 			
	BOOL IsEqualsIgnoreCase(CAnsiString& String);
	
	
	CAnsiString& Append(LPCSTR lpString); 
	CAnsiString& SetString(LPCSTR lpString);
	CAnsiString& SetString(LPCSTR lpString,DWORD nLength);
	CAnsiString& operator = (LPCSTR lpString);
	CAnsiString& operator +=(LPCSTR lpString);
	LPSTR operator() ();
	
	DWORD FindCount(CAnsiString& String);
	DWORD FindCount(CAnsiString& String, DWORD nStartPosition);
	DWORD FindCount(CAnsiString& String, DWORD nStartPosition, DWORD nMaxCount);
	
	CAnsiString& Replace( CAnsiString& StringOld, CAnsiString& StringNew );
	CAnsiString& Replace( CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition);
	CAnsiString& Replace( CAnsiString& StringOld, CAnsiString& StringNew, DWORD nStartPosition,DWORD nCount);

	
};

typedef CAnsiString AStr;
#endif
/*
This file is a part of CIF.
Project Core Information Foundation (CIF).
Developed by Muhammad Arshad Latti.
Location Sargodha (Pakistan).
arshadlatti@gmail.com
http://arshadlatti.angelfire.com/
*/
