#include "CBuffer.h"

CBuffer& CBuffer::operator = (CBuffer& rBuffer)
{
	if (this == &rBuffer) return *this;//mec
	
	SetBuffer(rBuffer);
	return *this;
}
void  CBuffer::_MakeAttachable(BOOL bAttachable)
{
	if (bAttachable)
		m_bAttachable = TRUE;
	else
		m_bAttachable = FALSE;
}
BOOL  CBuffer::_IsAttachable(void)
{
	if (m_bAttachable)
		return TRUE;
	return FALSE;
}
CBuffer& CBuffer::_GetAttachable(void)
{
	_MakeAttachable(TRUE);
	return *this;
}

char& CBuffer::GetAt( DWORD nIndex )
{
	return m_lpBuffer[nIndex];
}
void CBuffer::SetAt( DWORD nIndex , char ch )
{
	m_lpBuffer[nIndex] = ch;
}
char& CBuffer::operator[](DWORD nIndex)
{
	return m_lpBuffer[nIndex];
}

LPSTR CBuffer::_Allocate(DWORD dwBytes)
{
	if ( !dwBytes)
		return NULL;
	
	return new char[dwBytes];
}
void  CBuffer::_Free(LPSTR lpBytes)
{
	if (lpBytes)
		delete [] lpBytes;
}
void  CBuffer::_Attach(CBuffer& rBuffer)
{
	_Free(m_lpBuffer);
	
	m_nBufferSize = rBuffer.GetBufferSize();
	m_nDataSize = rBuffer.GetDataSize();;
	
	m_lpBuffer = rBuffer._Detach();
}
void  CBuffer::_Attach(LPSTR lpBuffer,DWORD dwBufferSize,DWORD dwDataSize) 
{
	_Free(m_lpBuffer);
	
	m_lpBuffer = lpBuffer;
	m_nBufferSize = dwBufferSize;
	m_nDataSize = dwDataSize;
}
LPSTR CBuffer::_Detach(void)
{
	LPSTR ptr = m_lpBuffer;
	
	m_lpBuffer = NULL;
	m_nBufferSize = ZERO;
	m_nDataSize = ZERO;
	
	return ptr;
}
DWORD CBuffer::ReadBuffer(LPVOID lpBuffer, DWORD nNumberOfBytesToRead)
{
	if (!nNumberOfBytesToRead)
		return ZERO;
	
	DWORD dwSize = nNumberOfBytesToRead;
	
	if ( nNumberOfBytesToRead > m_nBufferSize )
		dwSize = m_nBufferSize;
	
	if (dwSize)
		CopyMemory(lpBuffer,m_lpBuffer,dwSize);
	return dwSize;
}
DWORD CBuffer::ReadData(LPVOID lpBuffer, DWORD nNumberOfBytesToRead)
{
	if (!nNumberOfBytesToRead)
		return ZERO;
	
	DWORD dwSize = nNumberOfBytesToRead;
	
	if ( nNumberOfBytesToRead > m_nDataSize )
		dwSize = m_nBufferSize;
	
	if (dwSize)
		CopyMemory(lpBuffer,m_lpBuffer,dwSize);
	return dwSize;
}

CBuffer& CBuffer::operator ++()
{
	if ( m_nDataSize + 1 > m_nBufferSize)
		return *this;
	m_nDataSize++;
	return *this;
}
CBuffer& CBuffer::operator --()
{
	if (! m_nDataSize)
		return *this;
	m_nDataSize--;
	return *this;
}
BOOL  CBuffer::PrependData(CBuffer& rBuffer)
{
	CBuffer buff;
	DWORD nDataSize = rBuffer.GetDataSize() + GetDataSize();
	
	if ( nDataSize > m_nBufferSize)
	{
		if ( ! buff.SetBufferSize(nDataSize))
			return FALSE;
		if ( ! buff.SetData(rBuffer) )
			return FALSE;
		if ( ! buff.AppendData(*this) )
			return FALSE;
		_Attach(buff);
	}
	else
	{
		if ( ! buff.SetData(*this) )
			return FALSE;
		if ( ! SetData(rBuffer) )
			return FALSE;
		if ( ! AppendData(buff) )
			return FALSE;		
	}
	return TRUE;
}
BOOL  CBuffer::AppendData(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite)
{
	if (m_nDataSize == ZERO || m_lpBuffer == NULL)
		return WriteData(lpBuffer,nNumberOfBytesToWrite);
	
	if ( m_nDataSize + nNumberOfBytesToWrite > m_nBufferSize )
	{
		if ( ! SetBufferSize(m_nDataSize + nNumberOfBytesToWrite, TRUE) )
			return FALSE;
	}
	CopyMemory(&m_lpBuffer[m_nDataSize],lpBuffer,nNumberOfBytesToWrite);
	m_nDataSize += nNumberOfBytesToWrite;
	return TRUE;
	
}
BOOL  CBuffer::AppendData(CBuffer& rBuffer)
{
	if (m_nDataSize == ZERO || m_lpBuffer == NULL)
		return WriteData(rBuffer.GetPtr(),rBuffer.GetDataSize());
	
	if ( m_nDataSize + rBuffer.GetDataSize() > m_nBufferSize )
	{
		if ( ! SetBufferSize(m_nDataSize + rBuffer.GetDataSize(), TRUE) )
			return FALSE;
	}
	CopyMemory(&m_lpBuffer[m_nDataSize],rBuffer.GetPtr(),rBuffer.GetDataSize());
	m_nDataSize += rBuffer.GetDataSize();
	return TRUE;
}
BOOL  CBuffer::SetData(CBuffer& rBuffer)
{
	return WriteData(rBuffer.GetPtr(),rBuffer.GetDataSize());
	
}

LPSTR CBuffer::GetPtr(void)
{
	return m_lpBuffer;
}
LPSTR * CBuffer::GetPtrOfPtr(void)
{
	return &m_lpBuffer;
}
BOOL  CBuffer::SetDataSize(DWORD dwDataSize)
{
	if (dwDataSize > m_nBufferSize)
	{
		m_nDataSize = m_nBufferSize;
		return FALSE;
	}
	m_nDataSize = dwDataSize;
	return TRUE;	
}
DWORD CBuffer::GetBufferSize(void)
{
	return m_nBufferSize;
}
DWORD CBuffer::GetDataSize(void)
{
	return m_nDataSize;
}
void CBuffer::EmptyBuffer(void)
{
	if (m_lpBuffer)
		_Free(m_lpBuffer);
	
	m_lpBuffer = NULL;
	m_nBufferSize = ZERO;
	m_nDataSize = ZERO;
}
void CBuffer::EmptyData(void)
{
	m_nDataSize = ZERO;
}
BOOL CBuffer::IsEmptyBuffer(void)
{
	if (m_nBufferSize)
		return FALSE;
	return TRUE;
}
BOOL CBuffer::IsEmptyData(void)
{
	if (m_nDataSize)
		return FALSE;
	return TRUE;
}
CBuffer::CBuffer()
{
	m_lpBuffer = NULL;
	m_nBufferSize = ZERO;
	m_nDataSize = ZERO;
	m_bAttachable = FALSE;
}

CBuffer::~CBuffer()
{
	_Free(m_lpBuffer);
	
}
CBuffer::CBuffer(CBuffer& rBuffer)
{
	m_lpBuffer = NULL;
	m_bAttachable = FALSE;
	if ( rBuffer._IsAttachable() )
	{
		_Attach(rBuffer);
		rBuffer._MakeAttachable(FALSE);
		return;
	}
	
	WriteBuffer(rBuffer.GetPtr(), rBuffer.GetBufferSize());
	
	m_nBufferSize = rBuffer.GetBufferSize();
	m_nDataSize = rBuffer.GetDataSize();
}
CBuffer::CBuffer(CBuffer& rBuffer, BOOL bDataOnly)
{
	m_lpBuffer = NULL;
	m_nBufferSize = ZERO;
	m_nDataSize = ZERO;
	m_bAttachable = FALSE;
	
	
	if (bDataOnly)
		WriteBuffer(rBuffer.GetPtr(), rBuffer.GetDataSize());
	else
		WriteBuffer(rBuffer.GetPtr(), rBuffer.GetBufferSize());
	
	m_nDataSize = rBuffer.GetDataSize();
}
CBuffer::CBuffer(DWORD dwBufferSize)
{
	m_lpBuffer = NULL;
	m_nBufferSize = ZERO;
	m_nDataSize = ZERO;
	m_bAttachable = FALSE;
	
	SetBufferSize(dwBufferSize);
	
}
BOOL CBuffer::SetBufferSize(DWORD dwBufferSize, BOOL bKeepOldData)
{
	LPSTR ptr = m_lpBuffer;
	if ( ! dwBufferSize )
	{
		m_lpBuffer = NULL;
		m_nBufferSize = ZERO;
		m_nDataSize = ZERO;
		
		_Free(ptr);
		return TRUE;
	}
	
	m_lpBuffer = _Allocate(dwBufferSize);
	if (!m_lpBuffer)
	{
		m_lpBuffer = NULL;
		m_nBufferSize = ZERO;
		m_nDataSize = ZERO;
		
		_Free(ptr);
		return FALSE;
	}
	
	m_nBufferSize = dwBufferSize;
	if (bKeepOldData && m_nDataSize && ptr)
	{
		CopyMemory(m_lpBuffer,ptr,m_nDataSize);
	}
	else
	{
		m_nDataSize = ZERO;
	}
	_Free(ptr);
	return TRUE;
}
BOOL  CBuffer::WriteData(CBuffer& rBuffer, DWORD nNumberOfBytesToWrite)
{
	return WriteData(rBuffer.GetPtr(), nNumberOfBytesToWrite);
}
BOOL  CBuffer::WriteData(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite)
{
	if (!nNumberOfBytesToWrite)
	{
		m_nDataSize = ZERO;
		return TRUE;
	}
	
	if ( m_nBufferSize < nNumberOfBytesToWrite || m_lpBuffer == NULL)
		return WriteBuffer(lpBuffer,nNumberOfBytesToWrite);
	
	CopyMemory(m_lpBuffer, lpBuffer, nNumberOfBytesToWrite);
	m_nDataSize = nNumberOfBytesToWrite;
	return TRUE;
	
}
BOOL   CBuffer::WriteBuffer(CBuffer& rBuffer, DWORD nNumberOfBytesToWrite)
{
	return WriteBuffer(rBuffer.GetPtr(),nNumberOfBytesToWrite);
}
BOOL CBuffer::WriteBuffer(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite)
{
	LPSTR ptr = m_lpBuffer;
	
	if ( ! nNumberOfBytesToWrite )
	{
		m_lpBuffer = NULL;
		m_nBufferSize = ZERO;
		m_nDataSize = ZERO;
		
		_Free(ptr);
		return TRUE;
	}
	m_lpBuffer = _Allocate(nNumberOfBytesToWrite);
	if ( ! m_lpBuffer )
	{
		m_nBufferSize = ZERO;
		m_nDataSize = ZERO;
		
		_Free(ptr);
		return FALSE;
	}
	
	CopyMemory(m_lpBuffer, lpBuffer, nNumberOfBytesToWrite);
	m_nBufferSize = nNumberOfBytesToWrite;
	m_nDataSize = nNumberOfBytesToWrite;
	
	_Free(ptr);
	return TRUE;
}
BOOL  CBuffer::SetBuffer(CBuffer& rBuffer)
{
	if ( rBuffer._IsAttachable() )
	{
		_Attach(rBuffer);
		rBuffer._MakeAttachable(FALSE);
		return TRUE;
	}
	
	if (WriteBuffer(rBuffer.GetPtr(), rBuffer.GetBufferSize()))
	{
		m_nDataSize = rBuffer.GetDataSize();
		return TRUE;
	}
	return FALSE;
}
/*
This file is a part of CIF.
Project Core Information Foundation (CIF).
Developed by Muhammad Arshad Latti.
Location Sargodha (Pakistan).
arshadlatti@gmail.com
http://arshadlatti.angelfire.com/
*/
