#ifndef __C_BUFFER_H__
#define __C_BUFFER_H__

#include <Windows.h>

#ifndef ZERO
#define ZERO 0
#endif

class CBuffer
{
	LPSTR m_lpBuffer;
	DWORD m_nBufferSize;
	DWORD m_nDataSize;
	CHAR m_bAttachable;
public:
	CBuffer();
	CBuffer(CBuffer& rBuffer);
	CBuffer(CBuffer& rBuffer, BOOL bDataOnly);
	CBuffer(DWORD dwBufferSize);
	~CBuffer();
	void EmptyBuffer(void);
	void EmptyData(void);
	BOOL IsEmptyBuffer(void);
	BOOL IsEmptyData(void);
	
	DWORD GetBufferSize(void);
	DWORD GetDataSize(void);
	BOOL  SetBufferSize(DWORD dwBufferSize, BOOL bKeepOldData = FALSE);
	BOOL  SetDataSize(DWORD dwDataSize);
	LPSTR GetPtr(void);
	LPSTR * GetPtrOfPtr(void);
	BOOL  WriteBuffer(CBuffer& rBuffer, DWORD nNumberOfBytesToWrite);
	BOOL  WriteBuffer(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite);
	BOOL  WriteData(CBuffer& rBuffer, DWORD nNumberOfBytesToWrite);
	BOOL  WriteData(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite);
	
	DWORD  ReadBuffer(LPVOID lpBuffer, DWORD nNumberOfBytesToRead);
	DWORD  ReadData(LPVOID lpBuffer, DWORD nNumberOfBytesToRead);
	
	BOOL  AppendData(CBuffer& rBuffer);
	BOOL  AppendData(LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite);
	
	BOOL  PrependData(CBuffer& rBuffer);
	
	BOOL  SetBuffer(CBuffer& rBuffer); 
	BOOL  SetData(CBuffer& rBuffer);
	
	CBuffer& operator ++();
	CBuffer& operator --();
	CBuffer& operator = (CBuffer& rBuffer);
	
	LPSTR _Allocate(DWORD dwBytes);
	void  _Free(LPSTR lpBytes);
	void  _Attach(CBuffer& rBuffer); 
	void  _Attach(LPSTR lpBuffer,DWORD dwBufferSize,DWORD dwDataSize = 0); 
	LPSTR _Detach(void);
	void  _MakeAttachable(BOOL bAttachable);
	BOOL  _IsAttachable(void);
	CBuffer& _GetAttachable(void);
	
	char& GetAt( DWORD nIndex ); 
	void SetAt( DWORD nIndex , char ch);
	
	char& operator[](DWORD nIndex);  
	
	
};
#endif
/*
This file is a part of CIF.
Project Core Information Foundation (CIF).
Developed by Muhammad Arshad Latti.
Location Sargodha (Pakistan).
arshadlatti@gmail.com
http://arshadlatti.angelfire.com/
*/
