#ifndef __C_FILE_IO_H__
#define __C_FILE_IO_H__

#include "CBuffer.h"
#include "CAnsiString.h"

#ifndef INVALID_SET_FILE_POINTER
	#define INVALID_SET_FILE_POINTER        ((DWORD)-1)
#endif

class CFileIO
{
	HANDLE m_hFile;
public:
	CFileIO();
	~CFileIO();
	BOOL CreateNewFile(LPSTR lpFileName);
	BOOL OpenFile(LPSTR lpFileName);//OpenReadWrite
	BOOL OpenReadOnly(LPSTR lpFileName);
	BOOL OpenReadWrite(LPSTR lpFileName);
	BOOL OpenWriteOnly(LPSTR lpFileName);

	BOOL CreateFile(LPSTR lpFileName,DWORD dwDesiredAccess,DWORD dwShareMode,DWORD dwCreationDisposition);
	BOOL CloseFile(void);
	DWORD ReadFile(LPVOID lpBuffer,DWORD nNumberOfBytesToRead);
	BOOL WriteFile(LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite);
	
	BOOL SetFilePointer(LONG lDistanceToMove);
	DWORD GetFilePointer(void);
	HANDLE GetHandle(void);
	BOOL IsOpened(void);

	DWORD GetFileSize(void);
	BOOL  SetEndOfFile(void);
	BOOL  SeekToBOF(void);
	BOOL  SeekToEOF(void);

	//...
	BOOL ReadFile(CBuffer& rBuffer);
	BOOL WriteFile(CBuffer& rBuffer);
	BOOL CreateNewFile(CAnsiString& astrFileName);
	BOOL OpenFile(CAnsiString& astrFileName);//OpenReadWrite
	BOOL OpenReadOnly(CAnsiString& astrFileName);
	BOOL OpenReadWrite(CAnsiString& astrFileName);
	BOOL OpenWriteOnly(CAnsiString& astrFileName);

};

#endif
/*
This file is a part of CIF.
Project Core Information Foundation (CIF).
Developed by Muhammad Arshad Latti.
Location Sargodha (Pakistan).
arshadlatti@gmail.com
http://arshadlatti.angelfire.com/
*/
